const db = require('../models/db');

exports.getMovieInformations = (req, res, next) => {
    let filmId = req.params.id;

    db.query('SELECT * FROM Film WHERE tconst = ?',
        [filmId], function (error, results, fields) {

            if (error) {
                res.status(500).json({ error });
            } else {
                let infos = results[0];
                res.status(200).json(infos);
            }
        })
};

exports.searchMovie = (req, res, next) => {
    let search = req.query.title;

    db.query('SELECT * FROM Film WHERE primaryTitle LIKE CONCAT("%",?,"%") OR titleFR LIKE CONCAT("%",?,"%")',
        [search, search], function (error, results, fields) {
            if (error) {
                res.status(500).json({ error });
            }
            else {
                let searchResults = results;
                res.status(200).json(searchResults);
            }
        })

};

exports.getRecentlyReleasedMovies = (req, res, next) => {
    const numberOfMovies = req.query.numberOfMovies || 20;

    db.query('SELECT * FROM Film WHERE releaseDate <= CURDATE() ORDER BY releaseDate DESC LIMIT ?',
        [parseInt(numberOfMovies)], (error, results, fields) => {
            if (error) {
                res.status(500).json({ error });
            } else {
                res.status(200).json(results);
            }
        });
};
exports.getMovieCast = (req, res, next) => {
    let filmId = req.params.id;

    db.query('SELECT * FROM roles r JOIN personne p on r.nconst=p.nconst WHERE r.tconst = ?',
        [filmId], function (error, results, fields) {

            if (error) {
                res.status(500).json({ error });
            } else {
                let infos = results;
                res.status(200).json(infos);
            }
        })
};
exports.addMovieNote = (req, res, next) => {
    let filmId = req.query.id;
    let username = req.session.username;
    let note = req.query.note;

    if (checkMovieNoteExist(username, filmId)) {

        db.query('UPDATE Filmvue SET note=? WHERE login=? and tconst=?', [note, username, id],
            function (error, results, fields) {
                if (error == null) {
                    res.status(200).json({ message: 'Film préféré modifié' });
                }
                else {
                    res.status(500).json({ error });
                }

            })

    } else {

        db.query('INSERT INTO Filmvue VALUES (?,?,?)',
            [username, filmId, firstname, note],
            function (error, results, fields) {
                if (error == null) {
                    res.status(201).json({ message: 'Film préféré ajouté' });
                }
                else {
                    res.status(500).json({ error });
                }
            })
    }

};
async function checkMovieNoteExist(IdUser, IdFilm) {
    const queryResult = await new Promise((resolve, reject) => {
        db.query('SELECT * FROM Filmvue WHERE login=? and tconst=?',
            [IdUser, IdFilm],
            function (error, results, fields) {
                if (error) {
                    reject(error);
                } else {
                    resolve(results.length != 0);
                }
            })
    });
    return queryResult;
};

exports.getMovieNote = (req, res, next) => {
    let filmId = req.query.id;
    let username = req.session.username;
    console.log(filmId);
    console.log(username);
    db.query('SELECT note FROM Filmvue WHERE tconst = ? and login=?',
    [filmId, username], function (error, results, fields) {

        if (error) {
            res.status(500).json({ error });
        } else {
            console.log(results);
            let infos = results;
            res.status(200).json(infos);
        }
    })
};